#include <avr/io.h>
#include <avr/interrupt.h>

#include <util/delay.h>

#include <stdio.h>
#include <string.h>

#include "ST7735.h"
#include "colors.h"

int get_bit_from_byte(int byte, int bit) {
  return byte & (1 << bit);
}

void display_character(uint16_t x, uint16_t y, char character, uint16_t c_colour, uint16_t bg_colour) {
  int  i,j,byte,starting_index = character * 5;
  //TFTSetWindow(x, y, x + 4, y + 7);
  for ( i = 0; i < 8; i++) {
    for ( j = 0; j < 5; j++) {
       byte = font[starting_index + j];
      if (get_bit_from_byte(byte, i)) {
			TFTPixel(x-j,y-i,c_colour);
      } else {
		TFTPixel(x-j,y-i,bg_colour);
      }
    }
  }
}

void display_string(uint16_t x, uint16_t y, char *s, uint16_t c_colour, uint16_t bg_colour){
	int offset = 0;
	while (*s != '\0'){
		display_character(x - offset, y, *s, c_colour, bg_colour);
		offset+=5;
		s++;
	}
	
}

int main (void)
{
	TFTInit();
	TFTSetWindow(0, 0, 128, 160);
	int i, j;
	for (i = 0; i < 128; i++) {
		for (j = 0; j < 160; j++) {
			TFTPixel(i, j, BLACK);
		}
	}
		
	display_string(100, 100, "URBAN WALLET", WHITE, BLUE);
	
	//setez pin ca intrare
	DDRA &= ~(1 << PA0);
	//activez rezitenta de pull-up
	PORTA |= (1 << PA0);
	_delay_ms(50);
	int pressed = 0;
	while (pressed == 0) {
		if ((PINA & (1 << PA0)) == 0) {
			pressed = 1;
		}
	}
	
	for (i = 0; i < 128; i++) {
		for (j = 0; j < 160; j++) {
			TFTPixel(i, j, GREEN);
		}
	}
	
	display_string(100, 100, "URBAN WALLET", RED, WHITE);
	
	return 0;
}
